#include "ot4xb.ch"
// ---------------------------------------------------------------------------
proc main() 
local aMonitors,nMonitors,n
local nKey := 0

while nKey != 27
   CLS
   aMonitors := GetMonitorInfoArray()
   nMonitors := Len(aMonitors)
   for n := 1 to nMonitors
      ? cPrintf( "[Monitor#: %i] l:%4.4i t:%4.4i r:%4.4i b:%4.4i [%s] %s" ,;
                 n,;
                 aMonitors[n]:rcWork:left    ,;
                 aMonitors[n]:rcWork:top     ,;
                 aMonitors[n]:rcWork:right   ,;
                 aMonitors[n]:rcWork:bottom  ,;
                 aMonitors[n]:szDevice       ,;
                 iif( lAnd(aMonitors[n]:dwFlags,1) , "PRIMARY","") ;
               )
   next                           
   ? cPrintf( "Press [1 - %i] to select the monitor. Esc to close",nMonitors)
   nKey := inkey(0)
   if( (nKey > 48) .and. (nKey <= (48 + nMonitors) )  )
      CenterWindowInRect( SetAppWindow():GetHWnd() , aMonitors[nKey - 48]:rcWork )
   end
end
return         
// ---------------------------------------------------------------------------
function CenterWindowInRect( hWnd , oFRect )
local oWRect := RECT():New()        
local wcx,wcy,cx,cy,x,y
@user32:GetWindowRect(hWnd,oWRect)
wcx := oWRect:right  - oWRect:left
cx  := oFRect:right  - oFRect:left
x   := oFRect:left + ((cx-wcx) /2)
wcy := oWRect:bottom - oWRect:top 
cy  := oFRect:bottom - oFRect:top
y   := oFRect:top  + ((cy-wcy) /2)
@user32:SetWindowPos( hWnd,0,x,y,0,0,0x4005)
return NIL
// ---------------------------------------------------------------------------
function GetMonitorInfoArray()
local hData     := _Var2Con( {} )
@user32:EnumDisplayMonitors(0,0,_callback_MonitorEnumProc(),hData)
return _ConRelease(hData)
// ---------------------------------------------------------------------------
function MonitorEnumProc( hMonitor , hDC , pRect , hData )
local o      := MONITORINFOEX():New()
local aData  := _Con2Var( hData )
o:cbSize := o:_sizeof_()
if @user32:GetMonitorInfoA(hMonitor,o) != 0
  aAdd(aData,o)
else
  aAdd(aData,NIL)
end
return .T.
// ---------------------------------------------------------------------------
BEGIN STRUCTURE MONITORINFOEX
   MEMBER DWORD    cbSize 
   MEMBER @ RECT   rcMonitor
   MEMBER @ RECT   rcWork 
   MEMBER DWORD    dwFlags 
   MEMBER SZSTR    szDevice SIZE 32
END STRUCTURE
// ---------------------------------------------------------------------------
BEGIN STRUCTURE  RECT
  MEMBER LONG left 
  MEMBER LONG top 
  MEMBER LONG right 
  MEMBER LONG bottom 
END STRUCTURE
// ---------------------------------------------------------------------------



